﻿Public Class CompositeMessageConsumer(Of T)
    Implements IMessageConsumer(Of T)

    Private ReadOnly _consumers As IEnumerable(Of IMessageConsumer(Of T))

    Public Sub New(ByVal ParamArray consumers() As IMessageConsumer(Of T))
        Me._consumers = consumers
    End Sub

    Public ReadOnly Property Consumers As IEnumerable(Of IMessageConsumer(Of T))
        Get
            Return Me._consumers
        End Get
    End Property

#Region "IMessageConsumer<T> Members"

    Public Sub Consume(ByVal message As T) Implements IMessageConsumer(Of T).Consume
        For Each consumer In Me.Consumers
            consumer.Consume(message)
        Next consumer
    End Sub

#End Region
End Class