﻿Public Class CompositeReservationRoot
    Implements IReservationRepository

    Private ReadOnly _roots As IEnumerable(Of IReservationRepository)

    Public Sub New(ByVal ParamArray roots() As IReservationRepository)
        Me._roots = roots
    End Sub

    Public ReadOnly Property Roots As IEnumerable(Of IReservationRepository)
        Get
            Return Me._roots
        End Get
    End Property

#Region "IReservationRoot Members"

    Public Sub AddReservation(ByVal reservation As ReservationAcceptedEvent) Implements IReservationRepository.AddReservation
        For Each root In Me._roots
            root.AddReservation(reservation)
        Next root
    End Sub

#End Region
End Class