﻿Public Class ConditionalMessageConsumer(Of T)
    Implements IMessageConsumer(Of T)

    Private _condition As Func(Of T, Boolean)
    Private _first As IMessageConsumer(Of T)
    Private _second As IMessageConsumer(Of T)

    Public Sub New(ByVal condition As Func(Of T, Boolean),
                   ByVal first As IMessageConsumer(Of T),
                   ByVal second As IMessageConsumer(Of T)
                   )
        Me._condition = condition
        Me._first = first
        Me._second = second
    End Sub

    Public ReadOnly Property Condition As Func(Of T, Boolean)
        Get
            Return Me._condition
        End Get
    End Property

    Public ReadOnly Property First As IMessageConsumer(Of T)
        Get
            Return Me._first
        End Get
    End Property

    Public ReadOnly Property Second As IMessageConsumer(Of T)
        Get
            Return Me._second
        End Get
    End Property

#Region "IMessageConsumer<T> Members"

    Public Sub Consume(ByVal message As T) Implements IMessageConsumer(Of T).Consume
        Dim temp = If(Me.Condition(message), Me._first, Me._second)
        temp.Consume(message)
    End Sub

#End Region
End Class