﻿Imports Moq
Imports BookingDomainModel

Public Class AcceptingReservationConsumerFacts
    <Theory(), AutoDomainData()>
    Public Sub SutIsCorrectMessageConsumer(ByVal sut As AcceptingReservationConsumer)
        Assert.IsAssignableFrom(Of IMessageConsumer(Of MakeReservationCommand))(sut)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub ConsumePublishesEvent(<Frozen()> ByVal channelMock As Mock(Of IChannel),
                                     ByVal sut As AcceptingReservationConsumer,
                                     ByVal cmd As MakeReservationCommand
                                     )
        Dim expectedEvent = cmd.Accept().AsSource().OfLikeness(Of ReservationAcceptedEvent)()
        sut.Consume(cmd)
        channelMock.Verify(Sub(c) c.Send(expectedEvent))
    End Sub
End Class