﻿Imports Moq
Imports BookingDomainModel

Public Class ConstraintCheckingReservationConsumerFacts
    <Theory(), AutoDomainData()>
    Public Sub SutIsMessageConsumer(ByVal sut As ConstraintCheckingReservationConsumer)
        Assert.IsAssignableFrom(Of IMessageConsumer(Of MakeReservationCommand))(sut)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub ConsumeAddsIdToDateRoot(<Frozen()> ByVal readerStub As Mock(Of ICapacityReader),
                                       ByVal sut As ConstraintCheckingReservationConsumer,
                                       ByVal cmd As MakeReservationCommand,
                                       ByVal capacityMock As Mock(Of ICapacity)
                                       )
        readerStub.Setup(Function(r) r.GetCapacity(cmd.Date)).Returns(capacityMock.Object)
        sut.Consume(cmd)
        capacityMock.Verify(Sub(c) c.TryDecrement(cmd.Quantity))
    End Sub
End Class