﻿Imports BookingDomainModel

Public Class MakeReservationCommandFacts
    <Theory(), AutoDomainData()>
    Public Sub DateIsCorrect(<Frozen()> ByVal [date] As Date, ByVal sut As MakeReservationCommand)
        Assert.Equal(Of Date)([date], sut.Date)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub EmailIsCorrect(<Frozen()> ByVal email As String, ByVal sut As MakeReservationCommand)
        Assert.Equal(Of String)(email, sut.Email)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub NameIsCorrect(<Frozen()> ByVal name As String, ByVal sut As MakeReservationCommand)
        Assert.Equal(Of String)(name, sut.Name)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub QuantityIsCorrect(<Frozen()> ByVal quantity As Integer, ByVal sut As MakeReservationCommand)
        Assert.Equal(Of Integer)(quantity, sut.Quantity)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub IdIsUnique(ByVal sut As MakeReservationCommand, ByVal other As MakeReservationCommand)
        Assert.NotEqual(Of Guid)(other.Id, sut.Id)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub IdIsStable(ByVal sut As MakeReservationCommand)
        Assert.Equal(sut.Id, sut.Id)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub AcceptReturnsCorrectResult(ByVal sut As MakeReservationCommand)
        Dim expected = sut.AsSource().OfLikeness(Of ReservationAcceptedEvent)()
        Dim result = sut.Accept()
        expected.ShouldEqual(result)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub RejectReturnsCorrectResult(ByVal sut As MakeReservationCommand)
        Dim expected = sut.AsSource().OfLikeness(Of ReservationRejectedEvent)()
        Dim result = sut.Reject()
        expected.ShouldEqual(result)
    End Sub
End Class