﻿Imports Moq
Imports BookingDomainModel

Public Class PublishingReserverationRootFacts
    <Theory(), AutoDomainData()>
    Public Sub SutIsReservationRoot(ByVal sut As PublishingReserverationRoot)
        Assert.IsAssignableFrom(Of IReservationRepository)(sut)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub AddReservationPublishesEvent(<Frozen()> ByVal channelMock As Mock(Of IChannel),
                                            ByVal sut As PublishingReserverationRoot,
                                            ByVal reservation As ReservationAcceptedEvent
                                            )
        sut.AddReservation(reservation)
        channelMock.Verify(Sub(r) r.Send(reservation))
    End Sub
End Class