﻿Imports Moq
Imports BookingDomainModel

Public Class RejectingReservationConsumerFacts
    <Theory(), AutoDomainData()>
    Public Sub SutIsCorrectConsumer(ByVal sut As RejectingReservationConsumer)
        Assert.IsAssignableFrom(Of IMessageConsumer(Of MakeReservationCommand))(sut)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub ConsumePublishesEvent(<Frozen()> ByVal channelMock As Mock(Of IChannel),
                                     ByVal sut As RejectingReservationConsumer,
                                     ByVal cmd As MakeReservationCommand)
        Dim expectedEvent = cmd.Reject().AsSource().OfLikeness(Of ReservationRejectedEvent)()
        sut.Consume(cmd)
        channelMock.Verify(Sub(c) c.Send(expectedEvent))
    End Sub
End Class