﻿Imports Moq
Imports BookingDomainModel

Public Class ReservationWriterFacts
    <Theory(), AutoDomainData()>
    Public Sub SutIsMessageConsumer(ByVal sut As ReservationWriter)
        Assert.IsAssignableFrom(Of IMessageConsumer(Of MakeReservationCommand))(sut)
    End Sub

    <Theory(), AutoDomainData()>
    Public Sub ConsumeAddsReservationToRepository(<Frozen()> ByVal repositoryMock As Mock(Of IReservationRepository),
                                                  ByVal sut As ReservationWriter,
                                                  ByVal cmd As MakeReservationCommand)
        Dim expectedReseveration = cmd.Accept().AsSource().OfLikeness(Of ReservationAcceptedEvent)()
        sut.Consume(cmd)
        repositoryMock.Verify(Sub(r) r.AddReservation(It.Is(Of ReservationAcceptedEvent)(Function(e) expectedReseveration.Equals(e))))
    End Sub
End Class