﻿Imports BookingDomainModel

Public Class HomeController
    Inherits Controller
    Private ReadOnly channel As IChannel
    Private ReadOnly monthReader As IMonthViewReader
    Private ReadOnly dayReader As IDayViewReader

    Public Sub New(ByVal channel As IChannel,
                   ByVal monthReader As IMonthViewReader,
                   ByVal dayReader As IDayViewReader)
        Me.channel = channel
        Me.monthReader = monthReader
        Me.dayReader = dayReader
    End Sub

    Public Function Index() As ViewResult
        Dim now = Date.Now
        Dim model = Me.monthReader.Read(now.Year, now.Month)
        Return Me.View(model)
    End Function

    Public Function DisabledDays(ByVal year As Integer, ByVal month As Integer) As JsonResult
        Dim data = Me.monthReader.Read(year, month)
        Return Me.Json(data, JsonRequestBehavior.AllowGet)
    End Function

    Public Function NewBooking(ByVal year As Integer, ByVal month As Integer, ByVal day As Integer) As ViewResult
        Dim [date] = New Date(year, month, day)
        Dim remaining = Me.dayReader.GetRemainingCapacity([date])
        Dim model = New BookingViewModel With {.Date = [date], .Remaining = remaining}
        Return Me.View(model)
    End Function

    <HttpPost()>
    Public Function NewBooking(ByVal model As BookingViewModel) As ViewResult
        Me.channel.Send(model.MakeNewReservation())
        Return Me.View("BookingReceipt", model)
    End Function
End Class