﻿Imports BookingDomainModel
Imports BookingWebModel

Public Class BookingViewModelFacts
    <Theory(), AutoWebData()>
    Public Sub DateIsCorrect(<Frozen()> ByVal [date] As Date, ByVal sut As BookingViewModel)
        Assert.Equal([date], sut.Date)
    End Sub

    <Theory(), AutoWebData()>
    Public Sub NameIsCorrect(<Frozen()> ByVal name As String, ByVal sut As BookingViewModel)
        Assert.Equal(name, sut.Name)
    End Sub

    <Theory(), AutoWebData()>
    Public Sub EmailIsCorrect(<Frozen()> ByVal email As String, ByVal sut As BookingViewModel)
        Assert.Equal(Of String)(email, sut.Email)
    End Sub

    <Theory(), AutoWebData()>
    Public Sub QuantityIsCorrect(<Frozen()> ByVal quantity As Integer, ByVal sut As BookingViewModel)
        Assert.Equal(quantity, sut.Quantity)
    End Sub

    <Theory(), AutoWebData()>
    Public Sub RemainingEstimateIsProperWritableProper(ByVal sut As BookingViewModel, ByVal remaining As Integer)
        sut.Remaining = remaining
        Dim result = sut.Remaining
        Assert.Equal(remaining, result)
    End Sub

    <Theory(), AutoWebData()>
    Public Sub MakeNewReservationReturnsCorrectResult(ByVal sut As BookingViewModel)
        Dim result = sut.MakeNewReservation()
        Dim expected = sut.AsSource().OfLikeness(Of MakeReservationCommand)().Without(Function(d) d.Id)
        expected.ShouldEqual(result)
    End Sub
End Class