﻿Imports BookingWebModel

Public Class DayViewModelFacts
    <Theory(), AutoWebData()>
    Public Sub DayIsCorrect(<Frozen()> ByVal day As Integer, ByVal sut As DayViewModel)
        Assert.Equal(day, sut.Day)
    End Sub

    <Fact()>
    Public Sub SoldOutIsCorrect()
        'Fixture setup
        Dim fixture = New Fixture().Customize(New BookingWebModelCustomization)
        Dim sut = fixture.Build(Of DayViewModel)().OmitAutoProperties().CreateAnonymous()
        'Exercise system
        Dim result = sut.SoldOut
        'Verify outcome
        Assert.False(result)
        'Teardown
    End Sub

    <Theory(), InlineData(False), InlineData(True)>
    Public Sub SoldOutIsWellBehavedWritableProperty(ByVal soldOut As Boolean)
        'Fixture setup
        Dim fixture = New Fixture().Customize(New BookingWebModelCustomization)
        Dim sut = fixture.CreateAnonymous(Of DayViewModel)()
        'Exercise system
        sut.SoldOut = soldOut
        Dim result = sut.SoldOut
        'Verify outcome
        Assert.Equal(soldOut, result)
        'Teardown
    End Sub
End Class