﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.Mvc
Imports System.Web.Routing
Imports Castle.Windsor
Imports Microsoft.WindowsAzure
Imports Microsoft.WindowsAzure.ServiceRuntime
Imports BookingWebModel

' Note: For instructions on enabling IIS6 or IIS7 classic mode, 
' visit http://go.microsoft.com/?LinkId=9394801

Public Class MvcApplication
    Inherits HttpApplication
    Private ReadOnly container As IWindsorContainer

    Public Sub New()
        Me.container = New WindsorContainer().Install(New BookingWebRoleWindsorInstaller)
    End Sub

    Public Shared Sub RegisterRoutes(ByVal routes As RouteCollection)
        routes.IgnoreRoute("{resource}.axd/{*pathInfo}")

        routes.MapRoute(name:="Date",
                        url:="{controller}/{action}/{year}.{month}.{day}",
                        defaults:=New With {Key .controller = "Home",
                                            Key .action = "Index"},
                                        namespaces:={GetType(HomeController).Namespace})
        routes.MapRoute(name:="Default",
                        url:="{controller}/{action}/{id}",
                        defaults:=New With {Key .controller = "Home",
                                            Key .action = "Index",
                                            Key .id = UrlParameter.Optional},
                                        namespaces:={GetType(HomeController).Namespace})

    End Sub

    Protected Sub Application_Start()
        AreaRegistration.RegisterAllAreas()

        MvcApplication.RegisterRoutes(RouteTable.Routes)

        CloudStorageAccount.SetConfigurationSettingPublisher(
            Function(configName, configSetter) configSetter(RoleEnvironment.GetConfigurationSettingValue(configName)))

        ControllerBuilder.Current.SetControllerFactory(New WindsorControllerFactory(Me.container))
    End Sub

    Public Overrides Sub Dispose()
        Me.container.Dispose()
        MyBase.Dispose()
    End Sub
End Class