﻿Public Class WindsorControllerFactory
    Inherits DefaultControllerFactory
    Private ReadOnly container As IWindsorContainer

    Public Sub New(ByVal container As IWindsorContainer)
        If container Is Nothing Then Throw New ArgumentNullException("container")

        Me.container = container
    End Sub

    Protected Overrides Function GetControllerInstance(ByVal requestContext As RequestContext,
                                                       ByVal controllerType As Type) As IController
        Return CType(Me.container.Resolve(controllerType), IController)
    End Function

    Public Overrides Sub ReleaseController(ByVal controller As IController)
        Me.container.Release(controller)
    End Sub
End Class