﻿Imports System.Diagnostics

Public Class WorkerRole
    Inherits RoleEntryPoint
    Private container As IWindsorContainer
    Private ReadOnly cancellationTokenSource As CancellationTokenSource

    Public Sub New()
        Me.cancellationTokenSource = New CancellationTokenSource
    End Sub

    Public Overrides Sub Run()
        Trace.WriteLine("BookingWorkerRole entry point called", "Verbose")

        Dim messageHandler = New AzureQueueMessageProcessor(Me.container)
        messageHandler.Run(Me.cancellationTokenSource.Token)
    End Sub

    Public Overrides Function OnStart() As Boolean
        'Set the maximum number of concurrent connections 
        ServicePointManager.DefaultConnectionLimit = 12

        'DiagnosticMonitor.Start("DiagnosticsConnectionString");

        'For information on handling configuration changes
        'see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.
        'RoleEnvironment.Changing += RoleEnvironmentChanging;

        CloudStorageAccount.SetConfigurationSettingPublisher(Function(configName, configSetter) configSetter(RoleEnvironment.GetConfigurationSettingValue(configName)))

        '#warning Fix this in installer instead
        Dim account = CloudStorageAccount.FromConfigurationSetting("DataConnectionString")
        Dim client = account.CreateCloudTableClient()
        client.CreateTableIfNotExist("Reservations")
        client.CreateTableIfNotExist("MailMessages")

        Me.container = New WindsorContainer().Install(New BookingWorkerRoleWindsorInstaller)

        Return MyBase.OnStart()
    End Function

    Public Overrides Sub OnStop()
        Me.cancellationTokenSource.Cancel()
        Me.container.Dispose()
        MyBase.OnStop()
    End Sub

    'Private Sub RoleEnvironmentChanging(ByVal sender As Object, ByVal e As RoleEnvironmentChangingEventArgs)
    '    'If a configuration setting is changing
    '    If e.Changes.Any(Function(change) TypeOf change Is RoleEnvironmentConfigurationSettingChange) Then
    '        e.Cancel = True
    '    End If
    'End Sub
End Class