﻿Imports BookingDomainModel

Public Class AcceptedReserverationMailer
    Implements IMessageConsumer(Of ReservationAcceptedEvent)

    Private ReadOnly send As Action(Of MailMessage)
    Private ReadOnly sender As MailAddress

    Public Sub New(ByVal mailClient As Action(Of MailMessage), ByVal sender As MailAddress)
        Me.send = mailClient
        Me.sender = sender
    End Sub

#Region "IMessageConsumer<ReservationAcceptedEvent> Members"

    Public Sub Consume(ByVal message As ReservationAcceptedEvent) Implements BookingDomainModel.IMessageConsumer(Of BookingDomainModel.ReservationAcceptedEvent).Consume
        Dim msg = New MailMessage
        msg.From = Me.sender
        msg.To.Add(New MailAddress(message.Email))
        msg.Subject = "Your Reservation Was Accepted"
        msg.Body = String.Format("Dear {1}{0}{0}Thank you for your inquiry. We have the pleasure to inform you that we can accomodate {2} guest(s) at {3}. We look forward to seeing you.{0}{0}Regards",
                                 Environment.NewLine,
                                 message.Name,
                                 message.Quantity,
                                 message.Date.ToShortDateString())
        Me.send(msg)
    End Sub
#End Region
End Class