﻿Imports BookingDomainModel

Public Class RejectedReservationMailer
    Implements IMessageConsumer(Of ReservationRejectedEvent)

    Private ReadOnly mailClient As SmtpClient
    Private ReadOnly sender As MailAddress

    Public Sub New(ByVal mailClient As SmtpClient, ByVal sender As MailAddress)
        Me.mailClient = mailClient
        Me.sender = sender
    End Sub

#Region "IMessageConsumer<ReservationRejectedEvent> Members"

    Public Sub Consume(ByVal message As ReservationRejectedEvent) Implements BookingDomainModel.IMessageConsumer(Of BookingDomainModel.ReservationRejectedEvent).Consume
        Dim msg = New MailMessage
        msg.From = Me.sender
        msg.To.Add(New MailAddress(message.Email))
        msg.Subject = "Your Reservation Could Not Be Fulfilled"
        msg.Body = String.Format("Dear {1}{0}{0}Thank you for your inquiry. Unfortunately we must inform you that we can't accomodate {2} guest(s) at {3}. Please inquire again about another date.{0}{0}Regards",
                                 Environment.NewLine,
                                 message.Name,
                                 message.Quantity,
                                 message.Date.ToShortDateString())

        Me.mailClient.Send(msg)
    End Sub

#End Region
End Class